#include <iostream>
#include <vector>

using namespace std;

template <class T>
void QuickSort(vector<T>& a, int h, int t)
{
	int i=h, j=t;
	T k =a[(i+j)/2], tmp;
	do
	{
		while (a[i]<k) 
			{++i;}
		while (a[j]>k) 
			{
				//cout << a[j] << endl;
				--j;
			}
		if (i<=j) 
		{
			tmp = a[i]; a[i] = a[j]; a[j] = tmp;
			++i;
			--j;
		}
	} while (i<=j);

	if (h<j) {QuickSort(a,h,j);}
	if (i<t) {QuickSort(a,i,t);}
}

int main()
{
	vector<int> a,b;
	int N = 11;

	a.push_back(34);
	a.push_back(46);
	a.push_back(25);
	a.push_back(5);
	a.push_back(56);
	a.push_back(16);
	a.push_back(68);
	a.push_back(36);
	a.push_back(1);
	a.push_back(2);
	a.push_back(3);

	QuickSort(a,0,N-1);

	for (int i = 0; i<N-1; ++i)
	{
		cout << a[i] << " " << endl;
	}
	cout << endl;

	return 0;
}
