#include <iostream>

using namespace std;

class Max_heap
{
public:
	int a[100];
	int root; //root will be 1
	int len;
	
	//left child of node N will be N*2
	//right child of node N will be N*2+1

	Max_heap()
	{
		root = 0;
		len = 0;
	}

	void Add(int value)
	{
		if (len ==0) {++len; a[len] = value; root = 1; return;}

		++len;
		a[len] = value;
		int now = len;
		int tmp;
		while ((now != root) && (a[now]>a[now/2]))
		{
			tmp = a[now]; a[now] = a[now/2]; a[now/2] = tmp;
			now = now/2;
		}
	}


	void Print(int index)
	{
		//you can see the tree structure by matching (), left subtree will be in left (), and right subtree will be in right ()

		cout << "(";
		if (index*2<=len) {Print(index*2);}
		cout << a[index];
		if (index*2+1<=len) {Print(index*2+1);}
		cout << ")";
	}

	void heapify(int index)
	{
		int left = index * 2, right = index * 2 +1, largest = index;
		int tmp;

		if ((left <= len) && (a[left]>a[largest])) {largest = left;}
		if ((right <= len) && (a[right]>a[largest])) {largest = right;}

		if (largest != index)
		{
			tmp = a[index]; a[index] = a[largest]; a[largest] = tmp;
			heapify(largest);
		}
	}
	void remove()
	{
		//you can only pop the element from the top
		cout << a[1] << endl;
		a[1] = a[len];
		--len;
		heapify(1);
	}

};

int main()
{
	Max_heap H;
	
	H.Add(5);
	H.Add(10);
	H.Add(12);
	H.Add(15);
	H.Add(2);
	H.Add(30);



	H.Print(1);
	cout << endl;

	H.remove();
	H.Print(1);
	cout<< endl;
	H.remove();
	H.Print(1);
	cout<< endl;
	H.remove();
	H.Print(1);
	cout<< endl;

	return 0;
}
